rc revision 77662
1#!/bin/sh
2#
3# Copyright (c) 2000  The FreeBSD Project
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10#    notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12#    notice, this list of conditions and the following disclaimer in the
13#    documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27# $FreeBSD: head/etc/rc 77662 2001-06-03 20:15:13Z phk $
28#	From: @(#)rc	5.27 (Berkeley) 6/5/91
29#
30
31# System startup script run by init on autoboot
32# or after single-user.
33# Output and error are redirected to console by init,
34# and the console is the controlling terminal.
35
36# Note that almost all of the user-configurable behavior is no longer in
37# this file, but rather in /etc/defaults/rc.conf.  Please check that file
38# first before contemplating any changes here.  If you do need to change
39# this file for some reason, we would like to know about it.
40
41stty status '^T'
42
43# Set shell to ignore SIGINT (2), but not children;
44# shell catches SIGQUIT (3) and returns to single user after fsck.
45#
46trap : 2
47trap : 3	# shouldn't be needed
48
49bootmode=$1
50
51HOME=/
52PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin
53export HOME PATH
54
55# BOOTP diskless boot.  We have to run the rc file early in order to
56# retarget various config files.
57#
58if [ -r /etc/rc.diskless1 ]; then
59	dlv=`/sbin/sysctl -n vfs.nfs.diskless_valid 2> /dev/null`
60	if [ ${dlv:=0} != 0 ]; then
61		. /etc/rc.diskless1
62	fi
63fi
64
65# If there is a global system configuration file, suck it in.
66#
67if [ -r /etc/defaults/rc.conf ]; then
68	. /etc/defaults/rc.conf
69	source_rc_confs
70elif [ -r /etc/rc.conf ]; then
71	. /etc/rc.conf
72fi
73
74feed_dev_random() {
75	if [ -f "${1}" -a -r "${1}" -a -s "${1}" ]; then
76		echo "Using ${1} as an entropy file"
77		cat "${1}" | dd of=/dev/random bs=8k 2>/dev/null
78	fi
79}
80
81chkdepend() {
82	svc=$1
83	svc_var=$2
84	dep=$3
85	dep_var=$4
86
87	eval svc_val=\${$svc_var}
88	eval dep_val=\${$dep_var}
89
90	case ${svc_val} in
91	[Yy][Ee][Ss])
92		case ${dep_val} in
93		[Yy][Ee][Ss])
94		    ;;
95		*)
96		    eval ${dep_var}="YES"
97		    echo "DEPENDENCY NOTE: ${dep} will be enabled" \
98			 "to support ${svc}"
99		    ;;
100		esac
101		;;
102	esac
103}
104
105chkdepend amd amd_enable        portmap portmap_enable
106chkdepend NFS nfs_server_enable portmap portmap_enable
107chkdepend NIS nis_server_enable portmap portmap_enable
108chkdepend NIS nis_client_enable portmap portmap_enable
109
110# Enable harvesting of entropy via devices.  The sooner this happens the
111# better so that we can take advantage of the boot process.
112#
113echo -n 'Entropy harvesting:'
114
115case ${harvest_interrupt} in
116[Nn][Oo])
117	;;
118*)
119	if [ -w /dev/random ]; then
120		/sbin/sysctl -w kern.random.sys.harvest.interrupt=1 >/dev/null
121		echo -n ' interrupts'
122	fi
123	;;
124esac
125
126case ${harvest_ethernet} in
127[Nn][Oo])
128	;;
129*)
130	if [ -w /dev/random ]; then
131		/sbin/sysctl -w kern.random.sys.harvest.ethernet=1 >/dev/null
132		echo -n ' ethernet'
133	fi
134	;;
135esac
136
137case ${harvest_p_to_p} in
138[Nn][Oo])
139	;;
140*)
141	if [ -w /dev/random ]; then
142	/sbin/sysctl -w kern.random.sys.harvest.point_to_point=1 >/dev/null
143		echo -n ' point_to_point'
144	fi
145	;;
146esac
147
148echo '.'
149
150# First pass at reseeding /dev/random.
151#
152case ${entropy_file} in
153[Nn][Oo] | '')
154	;;
155*)
156	if [ -w /dev/random ]; then
157		feed_dev_random "${entropy_file}"
158	fi
159	;;
160esac
161
162# XXX temporary until we can get the entropy
163# harvesting rate up
164# Entropy below is not great,
165# but better than nothing.
166( ps -efauxww; sysctl -a; date; df -ib; dmesg; ps -efauxww; ) \
167    | dd of=/dev/random bs=8k 2>/dev/null
168cat /bin/ls | dd of=/dev/random bs=8k 2>/dev/null
169
170# Configure ccd devices.
171#
172if [ -r /etc/ccd.conf ]; then
173	ccdconfig -C
174fi
175
176case ${start_vinum} in
177[Yy][Ee][Ss])
178	vinum start
179	;;
180esac
181
182swapon -a
183
184case ${bootmode} in
185autoboot)
186	echo 'Automatic boot in progress...'
187	case ${background_fsck} in
188	[Yy][Ee][Ss])
189		fsck -F -p
190		;;
191	*)
192		fsck -p
193		;;
194	esac
195	case $? in
196	0)
197		;;
198	2)
199		exit 1
200		;;
201	4)
202		reboot
203		echo 'Reboot failed... help!'
204		exit 1
205		;;
206	8)
207		case ${fsck_y_enable} in
208		[Yy][Ee][Ss])
209			echo 'File system preen failed, trying fsck -y . . .'
210			fsck -y
211			case $? in
212			0)
213				;;
214			*)
215			echo 'Automatic file system check failed . . . help!'
216				exit 1
217				;;
218			esac
219			;;
220		*)
221			echo 'Automatic file system check failed . . . help!'
222			exit 1
223			;;
224		esac
225		;;
226	12)
227		echo 'Reboot interrupted'
228		exit 1
229		;;
230	130)
231		# interrupt before catcher installed
232		exit 1
233		;;
234	*)
235		echo 'Unknown error in reboot'
236		exit 1
237		;;
238	esac
239	;;
240*)
241	echo 'Skipping disk checks ...'
242	;;
243esac
244
245set -T
246trap "echo 'Reboot interrupted'; exit 1" 3
247
248# root normally must be read/write, but if this is a BOOTP NFS
249# diskless boot it does not have to be.
250#
251case ${root_rw_mount} in
252[Nn][Oo] | '')
253	;;
254*)
255	if ! mount -u -o rw / ; then
256		echo 'Mounting root filesystem rw failed, startup aborted'
257		exit 1
258	fi
259	;;
260esac
261
262umount -a >/dev/null 2>&1
263
264# Mount everything except nfs filesystems.
265mount -a -t nonfs
266
267case $? in
2680)
269	;;
270*)
271	echo 'Mounting /etc/fstab filesystems failed, startup aborted'
272	exit 1
273	;;
274esac
275
276# Run custom disk mounting function here
277#
278if [ -n "${diskless_mount}" -a -r "${diskless_mount}" ]; then
279		sh ${diskless_mount}
280fi
281
282# Reseed /dev/random with previously stored entropy.
283case ${entropy_dir} in
284[Nn][Oo])
285	;;
286*)
287	entropy_dir=${entropy_dir:-/var/db/entropy}
288	if [ -d "${entropy_dir}" ]; then
289		if [ -w /dev/random ]; then
290			for seedfile in ${entropy_dir}/*; do
291				feed_dev_random "${seedfile}"
292			done
293		fi
294	fi
295	;;
296esac
297
298case ${entropy_file} in
299[Nn][Oo] | '')
300	;;
301*)
302	if [ -w /dev/random ]; then
303		feed_dev_random "${entropy_file}"
304	fi
305	;;
306esac
307
308adjkerntz -i
309
310purgedir() {
311	local dir file
312
313	if [ $# -eq 0 ]; then
314		purgedir .
315	else
316		for dir
317		do
318		(
319			cd "$dir" && for file in .* *
320			do
321				[ ."$file" = .. -o ."$file" = ... ] && continue
322				if [ -d "$file" -a ! -L "$file" ]
323				then
324					purgedir "$file"
325				else
326					rm -f -- "$file"
327				fi
328			done
329		)
330		done
331	fi
332}
333
334clean_var() {
335	if [ ! -f /var/run/clean_var ]; then
336		purgedir /var/run /var/spool/lock
337		rm -rf /var/spool/uucp/.Temp/*
338		# Keep a copy of the boot messages around
339		dmesg >/var/run/dmesg.boot
340		# And an initial utmp file
341		(cd /var/run && cp /dev/null utmp && chmod 644 utmp;)
342		>/var/run/clean_var
343	fi
344}
345
346if [ -d /var/run -a -d /var/spool/lock -a -d /var/spool/uucp/.Temp ]; then
347	# network_pass1() *may* end up writing stuff to /var - we don't want to
348	# remove it immediately afterwards - *nor* to we want to fail to clean
349	# an nfs-mounted /var.
350	clean_var
351fi
352
353# Add additional swapfile, if configured.
354#
355case ${swapfile} in
356[Nn][Oo] | '')
357	;;
358*)
359	if [ -w "${swapfile}" -a -c /dev/mdctl ]; then
360		echo "Adding ${swapfile} as additional swap"
361		mdev=`mdconfig -a -t vnode -f ${swapfile}` && swapon /dev/${mdev}
362	fi
363	;;
364esac
365
366# Set sysctl variables as early as we can
367#
368if [ -r /etc/rc.sysctl ]; then
369	. /etc/rc.sysctl
370fi
371
372# Configure serial devices
373#
374if [ -r /etc/rc.serial ]; then
375	. /etc/rc.serial
376fi
377
378# Start up PC-card configuration
379#
380if [ -r /etc/rc.pccard ]; then
381	. /etc/rc.pccard
382fi
383
384# Start up the initial network configuration.
385#
386if [ -r /etc/rc.network ]; then
387	. /etc/rc.network	# We only need to do this once.
388	network_pass1
389fi
390
391case ${ipv6_enable} in
392[Yy][Ee][Ss])
393	if [ -r /etc/rc.network6 ]; then
394		. /etc/rc.network6	# We only need to do this once also.
395		network6_pass1
396	fi
397	;;
398esac
399
400# Mount NFS filesystems if present in /etc/fstab
401case "`mount -d -a -t nfs 2> /dev/null`" in
402*mount_nfs*)
403	echo -n 'Mounting NFS file systems:'
404	mount -a -t nfs
405	echo '.'
406	;;
407esac
408
409# Whack the pty perms back into shape.
410#
411if ls /dev/tty[pqrsPQRS]* > /dev/null 2>&1; then
412	chflags 0 /dev/tty[pqrsPQRS]*
413	chmod 666 /dev/tty[pqrsPQRS]*
414	chown root:wheel /dev/tty[pqrsPQRS]*
415fi
416
417# Clean up left-over files
418#
419clean_var			# If it hasn't already been done
420rm /var/run/clean_var
421
422# Clearing /tmp at boot-time seems to have a long tradition.  It doesn't
423# help in any way for long-living systems, and it might accidentally
424# clobber files you would rather like to have preserved after a crash
425# (if not using mfs /tmp anyway).
426#
427# See also the example of another cleanup policy in /etc/periodic/daily.
428#
429case ${clear_tmp_enable} in
430[Yy][Ee][Ss])
431	echo -n 'Clearing /tmp:'
432	# prune quickly with one rm, then use find to clean up /tmp/[lq]*
433	# (not needed with mfs /tmp, but doesn't hurt there...)
434	(cd /tmp && rm -rf [a-km-pr-zA-Z]* &&
435		find -d . ! -name . ! -name lost+found ! -name quota.user \
436		! -name quota.group -exec rm -rf -- {} \;)
437	echo '.'
438	;;
439esac
440
441# Remove X lock files, since they will prevent you from restarting X11
442# after a system crash.
443#
444rm -f /tmp/.X*-lock /tmp/.X11-unix/*
445
446# Snapshot any kernel -c changes back to disk here <someday>.
447# This has changed with ELF and /kernel.config.
448
449echo -n 'Additional daemons:'
450
451# Start system logging and name service.  Named needs to start before syslogd
452# if you don't have a /etc/resolv.conf.
453#
454case ${syslogd_enable} in
455[Yy][Ee][Ss])
456	# Transitional symlink (for the next couple of years :) until all
457	# binaries have had a chance to move towards /var/run/log.
458	if [ ! -L /dev/log ]; then
459		# might complain for r/o root f/s
460		ln -sf /var/run/log /dev/log
461	fi
462
463	rm -f /var/run/log
464	echo -n ' syslogd';	syslogd ${syslogd_flags}
465	;;
466esac
467
468# Start disk checking daemon if required.
469#
470case ${diskcheckd_enable} in
471[Yy][Ee][Ss])
472	echo -n ' diskcheckd'; diskcheckd ${diskcheckd_flags}
473	;;
474esac
475
476echo '.'
477
478# Build device name databases if we are not using DEVFS
479#
480if sysctl vfs.devfs.generation > /dev/null 2>&1 ; then
481	rm -f /var/run/dev.db
482else
483	dev_mkdb
484fi
485
486# Enable dumpdev so that savecore can see it.
487# /var/crash should be a directory or a symbolic link
488# to the crash directory if core dumps are to be saved.
489#
490case ${dumpdev} in
491[Nn][Oo] | '')
492	;;
493*)
494	if [ -e "${dumpdev}" -a -d /var/crash ]; then
495		/sbin/dumpon -v ${dumpdev}
496		echo -n 'Checking for core dump: '
497		/sbin/savecore ${savecore_flags} /var/crash
498	fi
499	;;
500esac
501
502if [ -n "${network_pass1_done}" ]; then
503	network_pass2
504fi
505
506# Enable/Check the quotas (must be after ypbind if using NIS)
507#
508case ${enable_quotas} in
509[Yy][Ee][Ss])
510	case ${check_quotas} in
511	[Yy][Ee][Ss])
512		echo -n 'Checking quotas:'
513		quotacheck -a
514		echo ' done.'
515		;;
516	esac
517
518	echo -n 'Enabling quotas:'
519	quotaon -a
520	echo ' done.'
521	;;
522esac
523
524if [ -n "${network_pass2_done}" ]; then
525	network_pass3
526fi
527
528# Check the password temp/lock file
529#
530if [ -e /etc/ptmp ]; then
531	logger -s -p auth.err \
532	"password file may be incorrect -- /etc/ptmp exists"
533fi
534
535case ${accounting_enable} in
536[Yy][Ee][Ss])
537	if [ -d /var/account ]; then
538		echo 'Turning on accounting:'
539		if [ ! -e /var/account/acct ]; then
540			touch /var/account/acct
541		fi
542		accton /var/account/acct
543	fi
544	;;
545esac
546
547# Make shared lib searching a little faster.  Leave /usr/lib first if you
548# add your own entries or you may come to grief.
549#
550ldconfig="/sbin/ldconfig"
551case ${ldconfig_insecure} in
552[Yy][Ee][Ss])
553	ldconfig="${ldconfig} -i"
554	;;
555esac
556if [ -x /sbin/ldconfig ]; then
557	case `/usr/bin/objformat` in
558	elf)
559		_LDC=/usr/lib
560		for i in ${ldconfig_paths}; do
561			if [ -d "${i}" ]; then
562				_LDC="${_LDC} ${i}"
563			fi
564		done
565		echo 'ELF ldconfig path:' ${_LDC}
566		${ldconfig} -elf ${_LDC}
567		;;
568	esac
569
570	# Legacy aout support for i386 only
571	case `sysctl -n hw.machine` in
572	i386)
573		# Default the a.out ldconfig path.
574		: ${ldconfig_paths_aout=${ldconfig_paths}}
575		_LDC=/usr/lib/aout
576		for i in ${ldconfig_paths_aout}; do
577			if [ -d "${i}" ]; then
578				_LDC="${_LDC} ${i}"
579			fi
580		done
581		echo 'a.out ldconfig path:' ${_LDC}
582		${ldconfig} -aout ${_LDC}
583		;;
584	esac
585fi
586
587# Now start up miscellaneous daemons that don't belong anywhere else
588#
589echo -n 'Starting standard daemons:'
590case ${inetd_enable} in
591[Nn][Oo])
592	;;
593*)
594	echo -n ' inetd';	inetd ${inetd_flags}
595	;;
596esac
597
598case ${cron_enable} in
599[Nn][Oo])
600	;;
601*)
602	echo -n ' cron';	${cron_program:-/usr/sbin/cron} ${cron_flags}
603	;;
604esac
605
606case ${lpd_enable} in
607[Yy][Ee][Ss])
608	echo -n ' printer';	${lpd_program:-/usr/sbin/lpd} ${lpd_flags}
609	;;
610esac
611
612case ${sshd_enable} in
613[Yy][Ee][Ss])
614	if [ -x ${sshd_program:-/usr/sbin/sshd} ]; then
615		echo -n ' sshd';
616		${sshd_program:-/usr/sbin/sshd} ${sshd_flags}
617	fi
618	;;
619esac
620
621case ${usbd_enable} in
622[Yy][Ee][Ss])
623	echo -n ' usbd';	/usr/sbin/usbd ${usbd_flags}
624	;;
625esac
626
627if [ -r /etc/mail/sendmail.cf ]; then
628	case ${sendmail_enable} in
629	[Yy][Ee][Ss])
630		echo -n ' sendmail'
631		/usr/sbin/sendmail ${sendmail_flags}
632		;;
633	*)
634		case ${sendmail_outbound_enable} in
635		[Yy][Ee][Ss])
636			echo -n ' sendmail'
637			/usr/sbin/sendmail ${sendmail_outbound_flags}
638			;;
639		esac
640		;;
641	esac
642fi
643
644echo '.'
645
646# Recover vi editor files.
647find /var/tmp/vi.recover ! -type f -a ! -type d -delete
648vibackup=`echo /var/tmp/vi.recover/vi.*`
649if [ "${vibackup}" != '/var/tmp/vi.recover/vi.*' ]; then
650	echo -n 'Recovering vi editor sessions:'
651	for i in /var/tmp/vi.recover/vi.*; do
652		# Only test files that are readable.
653		if [ ! -r "${i}" ]; then
654			continue
655		fi
656
657		# Unmodified nvi editor backup files either have the
658		# execute bit set or are zero length.  Delete them.
659		if [ -x "${i}" -o ! -s "${i}" ]; then
660			rm -f "${i}"
661		fi
662	done
663
664	# It is possible to get incomplete recovery files, if the editor
665	# crashes at the right time.
666	virecovery=`echo /var/tmp/vi.recover/recover.*`
667	if [ "${virecovery}" != "/var/tmp/vi.recover/recover.*" ]; then
668		for i in /var/tmp/vi.recover/recover.*; do
669			# Only test files that are readable.
670			if [ ! -r "${i}" ]; then
671				continue
672			fi
673
674			# Delete any recovery files that are zero length,
675			# corrupted, or that have no corresponding backup file.
676			# Else send mail to the user.
677			recfile=`awk '/^X-vi-recover-path:/{print $2}' < "${i}"`
678			if [ -n "${recfile}" -a -s "${recfile}" ]; then
679				sendmail -t < "${i}"
680			else
681				rm -f "${i}"
682			fi
683		done
684	fi
685	echo '.'
686fi
687
688# Make a bounds file for msgs(1) if there isn't one already
689#
690if [ -d /var/msgs -a ! -f /var/msgs/bounds -a ! -L /var/msgs/bounds ]; then
691	echo 0 > /var/msgs/bounds
692fi
693
694case ${update_motd} in
695[Nn][Oo] | '')
696	;;
697*)
698	if T=`mktemp /tmp/_motd.XXXXXX`; then
699		uname -v | sed -e 's,^\([^#]*\) #\(.* [1-2][0-9][0-9][0-9]\).*/\([^\]*\) $,\1 (\3) #\2,' > ${T}
700		awk '{if (NR == 1) {if ($1 == "FreeBSD") {next} else {print "\n"$0}} else {print}}' < /etc/motd >> ${T}
701		cmp -s ${T} /etc/motd || {
702			cp ${T} /etc/motd
703			chmod 644 /etc/motd
704		}
705		rm -f ${T}
706	fi
707	;;
708esac
709
710# Configure implementation specific stuff
711#
712arch=`uname -m`
713if [ -r /etc/rc.${arch} ]; then
714	. /etc/rc.${arch}
715fi
716
717# Configure the system console
718#
719if [ -r /etc/rc.syscons ]; then
720	. /etc/rc.syscons
721fi
722
723# Run rc.devfs if readable to customize devfs
724#
725if [ -r /etc/rc.devfs ]; then
726	sh /etc/rc.devfs
727fi
728
729echo -n 'Additional ABI support:'
730
731# Load the SysV IPC API if requested.
732case ${sysvipc_enable} in
733[Yy][Ee][Ss])
734	echo -n ' sysvipc'
735	kldload sysvmsg >/dev/null 2>&1
736	kldload sysvsem >/dev/null 2>&1
737	kldload sysvshm >/dev/null 2>&1
738	;;
739esac
740
741# Start the Linux binary compatibility if requested.
742#
743case ${linux_enable} in
744[Yy][Ee][Ss])
745	echo -n ' linux'
746	if ! kldstat -v | grep -E 'linux(aout|elf)' > /dev/null; then
747		kldload linux > /dev/null 2>&1
748	fi
749	if [ -x /compat/linux/sbin/ldconfig ]; then
750		/compat/linux/sbin/ldconfig
751	fi
752	;;
753esac
754
755# Start the SysVR4 binary emulation if requested.
756#
757case ${svr4_enable} in
758[Yy][Ee][Ss])
759	echo -n ' svr4';	kldload svr4 > /dev/null 2>&1
760	;;
761esac
762
763echo '.'
764
765# Do traditional (but rather obsolete) rc.local file if it exists.  If you
766# use this file and want to make it programmatic, source /etc/defaults/rc.conf
767# in /etc/rc.local and add your custom variables to /etc/rc.conf, as
768# shown below.  Please do not put local extensions into /etc/rc itself.
769# Use /etc/rc.local
770#
771# ---- rc.local ----
772#	if [ -r /etc/defaults/rc.conf ]; then
773#		. /etc/defaults/rc.conf
774#		source_rc_confs
775#	elif [ -r /etc/rc.conf ]; then
776#		. /etc/rc.conf
777#	fi
778#
779#	... additional startup conditionals ...
780# ---- rc.local ----
781#
782if [ -r /etc/rc.local ]; then
783	echo -n 'Starting local daemons:'
784	sh /etc/rc.local
785	echo '.'
786fi
787
788# For each valid dir in $local_startup, search for init scripts matching *.sh
789#
790case ${local_startup} in
791[Nn][Oo] | '')
792	;;
793*)
794	echo -n 'Local package initialization:'
795	for dir in ${local_startup}; do
796		if [ -d "${dir}" ]; then
797			for script in ${dir}/*.sh; do
798				if [ -x "${script}" ]; then
799					(set -T
800					 trap 'exit 1' 2
801					 ${script} start)
802				fi
803			done
804		fi
805	done
806	echo '.'
807	;;
808esac
809
810if [ -n "${network_pass3_done}" ]; then
811	network_pass4
812fi
813
814# Raise kernel security level.  This should be done only after `fsck' has
815# repaired local file systems if you want the securelevel to be greater than 1.
816#
817case ${kern_securelevel_enable} in
818[Yy][Ee][Ss])
819	if [ "${kern_securelevel}" -ge 0 ]; then
820		echo 'Raising kernel security level: '
821		sysctl -w kern.securelevel=${kern_securelevel}
822	fi
823	;;
824esac
825
826# Start background fsck checks if necessary
827case ${background_fsck} in
828[Yy][Ee][Ss])
829	echo 'Starting background filesystem checks'
830	nice -4 fsck -B -p 2>&1 | logger -p daemon.notice &
831	;;
832esac
833
834echo ''
835
836date
837
838exit 0
839
840